! ===================================================================================================\n
! MODULE        : tests_array
!
! CONTACT       : orchidee-help _at_ listes.ipsl.fr
!
! LICENCE       : IPSL (2006)
! This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
!
!>\BRIEF        
!!
!!\n DESCRIPTION : 
!!
!! RECENT CHANGE(S) : None
!!
!! REFERENCE(S) :
!!
!! SVN          :
!! $HeadURL: svn://forge.ipsl.jussieu.fr/orchidee/branches/ORCHIDEE-MICT/ORCHIDEE/src_sechiba/hydrol.f90 $
!! $Date: 2018-10-09 11:43:16 +0200 (Tue, 09 Oct 2018) $
!! $Revision: 5477 $
!! \n
!_ ===============================================================================================\n
MODULE tests_forcing_digest

  USE ioipsl_para
  USE ioipsl_lists
  USE forcing

  IMPLICIT NONE

  PRIVATE
  PUBLIC :: tests_forcing_digest_main

  !
  ! variables used inside this module : declaration and initialisation
  !

CONTAINS

!! ================================================================================================================================
!! SUBROUTINE 	: tests_forcing_digest_main
!!
!>\BRIEF         
!!
!! DESCRIPTION :
!!
!! MAIN OUTPUT VARIABLE(S) : 
!!
!! REFERENCE(S) : 
!!
!! FLOWCHART    : None
!! \n
!_ ================================================================================================================================
  SUBROUTINE tests_forcing_digest_main()

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables

  !_ ======================================================================================================
    CALL tests_forcing_digest_single
!    CALL tests_forcing_digest_multiple
          
  END SUBROUTINE tests_forcing_digest_main
  
!! ================================================================================================================================
!! SUBROUTINE 	: tests_forcing_digest_single
!!
!>\BRIEF         
!!
!! DESCRIPTION :
!!
!! MAIN OUTPUT VARIABLE(S) : 
!!
!! REFERENCE(S) : 
!!
!! FLOWCHART    : None
!! \n
!_ ================================================================================================================================
  SUBROUTINE tests_forcing_digest_single

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables
    TYPE(t_forcing_list) :: flist
    CHARACTER(LEN=:), ALLOCATABLE :: test_title

    CHARACTER(LEN=300), PARAMETER :: str_files = " somefile.nc  " 
    TYPE(T_FORCING_LIST) :: forcing_list

  !_ ======================================================================================================
    WRITE(*,*) "========================================================================"
    test_title = "tests_forcing_digest_single" 
    WRITE(*,*) "Test "//test_title

    flist = T_FORCING_LIST(str_files, .FALSE.) 

    IF ( flist%total() .EQ. 1 .AND. &
          flist%get(1) .EQ. TRIM(str_files) ) THEN
       WRITE(*,*) "Test "//test_title//": Successful"
    ELSE
       WRITE(*,*) "Test "//test_title//": failed"
       WRITE(*,*) "Expected:", str_files
       WRITE(*,*) "Found(1):", flist%get(1)
    ENDIF
          
  END SUBROUTINE tests_forcing_digest_single

!! ================================================================================================================================
!! SUBROUTINE 	: tests_forcing_digest_multiple
!!
!>\BRIEF         
!!
!! DESCRIPTION :
!!
!! MAIN OUTPUT VARIABLE(S) : 
!!
!! REFERENCE(S) : 
!!
!! FLOWCHART    : None
!! \n
!_ ================================================================================================================================
  SUBROUTINE tests_forcing_digest_multiple

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables
    TYPE(t_forcing_list) :: flist
    CHARACTER(LEN=:), ALLOCATABLE :: test_title

    CHARACTER(LEN=500), PARAMETER :: str_files = " somefile.nc  moreinfo.nc     anotherfile.nc " 
    TYPE(T_FORCING_LIST) :: forcing_list

  !_ ======================================================================================================
    WRITE(*,*) "========================================================================"
    test_title = "tests_forcing_digest_multiple" 
    WRITE(*,*) "Test "//test_title

    flist = T_FORCING_LIST(str_files, .FALSE.) 

    IF ( flist%total() .EQ. 3 .AND. &
          flist%get(1) .EQ. "somefile.nc" .AND. & 
          flist%get(2) .EQ. "moreinfo.nc" .AND. &
          flist%get(3) .EQ. "anotherfile.nc" ) THEN
       WRITE(*,*) "Test "//test_title//": Successful"
    ELSE
       WRITE(*,*) "Test "//test_title//": failed"
       WRITE(*,*) "Expected:", TRIM(str_files)
       WRITE(*,*) "Found(1):", TRIM(flist%get(1))
       WRITE(*,*) "Found(2):", TRIM(flist%get(2))
       WRITE(*,*) "Found(3):", TRIM(flist%get(3))
    ENDIF
          
  END SUBROUTINE tests_forcing_digest_multiple
  
END MODULE tests_forcing_digest
